#ifndef RADIO_H_
#define RADIO_H_

#include "stm32f1xx_hal.h"
#include "stm32f1xx_hal_i2c.h"

class Radio {
	enum RadioStateEnum{
		Radio_notInitialized=0,
		Radio_Initialized=1,
		Radio_Activated=2,
		Radio_Running=3,
	};
private:
	I2C_HandleTypeDef *hi2c2;
	uint16_t ui16DevAddress;
	uint8_t ai8RxBuffer[10];
	uint8_t ai8Txbuffer[10];
	uint8_t ui8LastStatus;
	RadioStateEnum stateChip;
public:
	Radio(I2C_HandleTypeDef *phi2c2);
	void Radio_activate(int);
	void Radio_Run(void);
	virtual ~Radio();
};

#endif /* RADIO_H_ */
